<?php

/*

Copyright 2018 Murray Hayes

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

3. Neither the name of the copyright holder nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

*/


session_start();

include_once "utils.php";
include_once "DOMUtils.php";
include_once "consts.php";
include_once "database.php";
include_once "adminUtils.php";
include_once "trainingUtils.php";

$doc = returnDoc();
$root = returnRoot($doc);

//if (!isset($_SESSION['login']) || !isset($_SESSION['MemberID']))
if (!validateSession())
  if (!isset($_SESSION['cookieMonster']))
    generateCookieMonster();
  else
    generateLoginRedirect();
else
  if (($_SESSION['login'] === TRUE) && returnAdminStatus($_SESSION['MemberID']))
  {
    if ($_SERVER['REQUEST_METHOD'] == 'POST')
    {
      /*
       *  validate form data.
       */
      if (isset($_POST['classID']) && isset($_POST['Update']) && isset($_POST['status'])) // && isset($_POST['description'])) 
      {
        
        $classID = (int) cleanInput($_POST['classID']);
        /*
        try
        {
          $dbh = returnDatabaseHandel();
          $dbh->beginTransaction();
          $sth = $dbh->prepare("UPDATE class_registrants SET attendance_status = 'no'");
          $sth->execute();
          $sth = $dbh->prepare("UPDATE class_registrants SET attendance_status = 'yes' WHERE member_id = ?");
          
          
          foreach ($_POST as $attendee => $status)
          {
            if ($status === "Attended")
            $sth->execute(array($attendee));
          }
          $dbh->commit();
          
          
          /*
          $insert = TRUE;
          //print_r(PDO::getAvailableDrivers());
          $dbh = returnDatabaseHandel();
          //$dbh->beginTransaction();
          $sth = $dbh->prepare("SELECT * FROM courses");
          $count = 0;
          if ($sth->execute())
          {
            while ($row = $sth->fetch(PDO::FETCH_ASSOC))
            {
              if ($row['id'] === $_POST['id'])
              {
                $insert = FALSE;
              }
            }
            //echo "here";
            if ($insert)
            {
              $sth = $dbh->prepare("INSERT INTO courses (id, name, description) values (?, ?, ?)");
              $sth->execute(array($_POST['id'], $_POST['name'], $_POST['description']));
            }
            else
            {
              $dbh->beginTransaction();
              $sth = $dbh->prepare("UPDATE courses SET name = ?, description = ? WHERE id = ?");
              $sth->execute(array($_POST['name'], $_POST['description'], $_POST['id']));
              //print_r($sth->errorInfo());
              $dbh->commit();
            }
          }
        }
        catch (Exception $e)
        {
          $dbh->rollBack();
          print ("Fail! " . $e->getMessage() . "\n");
        }*/
        $status = cleanInput($_POST['status']);
        
        if ($status === "NoShow" || $status === "Attended" ||
            $status === "Rescheduled" || $status === "Confirmed" ||
            $status === "Withdrawn" || $status === "Registered")
        {
          updateAttendenceTable($classID, $status);
        }
      }
    }
    
    $root = $doc->appendChild($root);
    $root->appendChild(generateHead($doc));
    
    $body = $doc->createElement('body');
    $root->appendChild($body);
    
    $body->appendChild(generateMastHead($doc, $baseDir));
    
    //$body->appendChild($doc->createElement('hr'));
    
    
    /*$body->appendChild(generateMemberNavigationBar($doc));
    if (returnInstructorStatus($_SESSION['MemberID']))
      if ($_SESSION['sub_nav'] === "Admin")
        $body->appendChild(generateAdminNavigationBar($doc));
      else
        if ($_SESSION['sub_nav'] === "Director")
          $body->appendChild(generateDirectorNavigationBar($doc));
        else
          $body->appendChild(generateTrainingNavigationBar($doc));
    else 
      if (returnAdminStatus($_SESSION['memberID']))
        $body->appendChild(generateAdminNavigationBar($doc)); */
    
    /*
     *  Do not set session sub nav
     */
      
    $body->appendChild(generateSelectedMenuBar($doc));
      
    /*
     *  Insert content here.
     */
    
    //print_r($_POST);
        
    $bodyDiv = $doc->createElement('div');
    $bodyDiv->setAttribute('class', 'BodyDiv');
    
    if (returnInstructorStatus($_SESSION['MemberID']) || returnAdminStatus($_SESSION['MemberID']) || returnDirectorStatus($_SESSION['MemberID']))
    {
      if (isset($_POST['classID']))
        $bodyDiv->appendChild(generateClassSelector($doc, (int) cleanInput($_POST['classID']))); // $_POST is only used for comparison in this function
      else
        $bodyDiv->appendChild(generateClassSelector($doc));
      
      $bodyDiv->appendChild($doc->createElement('hr'));

      if (isset($_POST['classID']))
      {
        $classID = (int) cleanInput($_POST['classID']);
        $bodyDiv->appendChild(generateAttendanceForm($doc, $classID));
        $bodyDiv->appendChild($doc->createElement('br'));
        $text = $doc->createElement('H3');
        $text->appendChild($doc->createTextNode(getCourseTitleFromClassID($classID)));
        $bodyDiv->appendChild($text);
        $text = $doc->createElement('p');
        $text->appendChild($doc->createTextNode(getCourseDescriptionFromClassID($classID)));
        $bodyDiv->appendChild($text);
        
      }
    }

    $body->appendChild($bodyDiv);
    $body->appendChild(generateFooter($doc));
    if ($prettyPretty)
      $doc->formatOutput = true;
    echo $doc->saveXML();
  }
else
  generateIndexRedirect();
      
?>