<?php

/*

Copyright 2018 Murray Hayes

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

3. Neither the name of the copyright holder nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

*/


session_start();

include_once "utils.php";
include_once "DOMUtils.php";
include_once "consts.php";
include_once "database.php";

date_default_timezone_set($timeZone);

if (isset($_SESSION['cookieMonster']))
//if (true)
{
  $doc = returnDoc();
  
  $root = returnRoot($doc);
  $root = $doc->appendChild($root);
  $root->appendChild(generateHead($doc));
  
  $body = $doc->createElement('body');
  $root->appendChild($body);
  
  $body->appendChild(generateMastHead($doc, $baseDir));
  
  if (isset($_SESSION['login']))
    if ($_SESSION['login'] === TRUE)
      $body->appendChild(generateSelectedMenuBar($doc));
    
      //$body->appendChild(generateMemberNavigationBar($doc));
  
  //$body->appendChild($doc->createElement('hr'));
  
  /*
   * $welcome = $doc->createElement('div');
   * $welcomeHeader = $doc->createElement('h3');
   * $welcomeHeader->appendChild($doc->createTextNode('Welcome to the members database for Protospace'));
   * $welcome->appendChild($welcomeHeader);
   *
   * $body->appendChild($welcome);
   
  $body->appendChild(generateMenuList($doc, $baseDir, array (
      array (
          'index.php',
          'My transactions' ),
      array (
          'login.php',
          'Login for more options' ),
      array (
          'school.php',
          'Classes, courses, seminars, events and fun for all!' ) )));
  
  // $body->appendChild($welcome);*/
  
  $bodyDiv = $doc->createElement('div');
  $bodyDiv->setAttribute('id', 'BodyDiv');
  
  $bodyDiv->appendChild(generateStatus($doc));
  
  $briefTable = generateBriefTrainingTable($doc, 20);
  
  if ($briefTable === FALSE)
  {
  }
  else
    $bodyDiv->appendChild($briefTable);
  
  
  /*, array (
      createCourseInfo("Monthly Cleanup and Group Lunch", 11257, "Sat, Jan 20, 9:30 AM", 11, 88),
      createCourseInfo("New Members: Orientation and Basic Safety", 11245, "Sat, Jan 20, 2:00 PM", 11, 1),
      createCourseInfo("Woodworking: Stationary Saws", 11266, "Sun, Jan 21, 12:00 PM", 5, 0),
      createCourseInfo("Electronics: Creating PCBs with Free Software (Part 1)", 11261, "Sat, Jan 27, 10:00 AM", 8, 0),
      createCourseInfo("Electronics: Creating PCBs with Free Software (Part 2)", 11262, "Sun, Jan 28, 10:00 AM", 8, 0),
      createCourseInfo("Test: How to Donate!", 11258, "Wed, Jan 31, 11:45 PM", 1, 11) )));
  */
  
  
  $body->appendChild($bodyDiv);
  
  //$body->appendChild($doc->createElement('br'));
  
  $body->appendChild(generateFooter($doc));
  if ($prettyPretty)
    $doc->formatOutput = true;
  outputDoc($doc);
}
else
{
  generateCookieMonster();
}

?>


