<?php


/*

Copyright 2018 Murray Hayes

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

3. Neither the name of the copyright holder nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

*/


session_start();

include_once "utils.php";
include_once "DOMUtils.php";
include_once "consts.php";
include_once "database.php";
include_once "adminUtils.php";

$doc = returnDoc();
$root = returnRoot($doc);

//if (!isset($_SESSION['login']) || !isset($_SESSION['MemberID']))
if (!validateSession())
  if (!isset($_SESSION['cookieMonster']))
    generateCookieMonster();
  else
    generateLoginRedirect();
else
  if (($_SESSION['login'] === TRUE))
  {
    if ($_SERVER['REQUEST_METHOD'] == 'POST' && isset($_SESSION['MemberID']))
    {
      //print_r($_POST);
      /*
       *  Process form here
       */
      if (isset($_POST['Activate']))
      {
        try
        {
          //print ("checking...");
          $dbh = returnDatabaseHandel();
          $dbh->beginTransaction();
          $sth = $dbh->prepare($statement240);
          if ($sth->execute(array($_SESSION['MemberID'])))
          {
            $stb = $dbh->prepare($statement242);
            while ($row = $sth->fetch(PDO::FETCH_ASSOC))
            {
              foreach ($_POST as $post => $value)
              {
                //print("post $post and value $value are ${row['id']}");
                if ((int) $post === (int) $row['id'] && (int) $value === (int) $row['id'])
                {
                  //print ("activating...");
                  $stb->execute(array($_SESSION['MemberID'], $row['id']));
                }
              }
            }
          }
          $dbh->commit();
        }
        catch (Exception $e)
        {
          print ("Failed to activate tools " . $e->getMessage());
          $dbh->rollBack();
        }
      }
      else
        if (isset($_POST['Deactivate']))
        {
          try
          {
            $dbh = returnDatabaseHandel();
            $dbh->beginTransaction();
            $sth = $dbh->prepare($statement241);
            if ($sth->execute(array($_SESSION['MemberID'])))
            {
              $stb = $dbh->prepare($statement243);
              while ($row = $sth->fetch(PDO::FETCH_ASSOC))
              {
                foreach ($_POST as $post => $value)
                {
                  if ((int) $post === (int) $row['id'] && (int) $value === (int) $row['id'])
                  {
                    $stb->execute(array($row['id']));
                  }
                }
              }
            }
            $dbh->commit();
          }
          catch (Exception $e)
          {
            print ("Failed to deactivate tools " . $e->getMessage());
            $dbh->rollBack();
          }
        }
        else
          if (isset($_POST['DeactivateAll']))
          {
            try
            {
              $dbh = returnDatabaseHandel();
              $dbh->beginTransaction();
              $sth = $dbh->prepare($statement244);
              if ($sth->execute(array($_SESSION['MemberID'])))
              {
                
              }
              $dbh->commit();
            }
            catch (Exception $e)
            {
              print ("Failed to deactivate all authorized tools " . $e->getMessage());
              $dbh->rollBack();
            }
          }
    }
    
    
    $root = $doc->appendChild($root);
    $root->appendChild(generateHead($doc));
    
    $body = $doc->createElement('body');
    $root->appendChild($body);
    
    $body->appendChild(generateMastHead($doc, $baseDir));
    
    //$body->appendChild($doc->createElement('hr'));
    $_SESSION['subNav'] = NULL;
    $body->appendChild(generateSelectedMenuBar($doc));
    
    $h3 = $doc->createElement('h3');
    $h3->appendChild($doc->createTextNode("Tool Activation"));
    $body->appendChild($h3);
    
    $formDiv = createDiv($doc);
    $form = createForm($doc, "toolActivation.php");
    
    
    $form->appendChild(populateToolActivationTable($doc, $_SESSION['MemberID']));
    
    $input = createSubmitInput($doc, 'Activate', $text0015);
/*    $input = $doc->createElement('input');
    $input->setAttribute('type', 'submit');
    $input->setAttribute('name', 'Activate');
    $input->setAttribute('value', 'Activate');*/
    $form->appendChild($input);

    $input = createSubmitInput($doc, 'Deactivate', $text0016);
/*    $input = $doc->createElement('input');
    $input->setAttribute('type', 'submit');
    $input->setAttribute('name', 'Deactivate');
    $input->setAttribute('value', 'Deactivate'); */
    $form->appendChild($input);
    
    $input = createSubmitInput($doc, 'DeactiavateAll', $text0017);
/*    $input = $doc->createElement('input');
    $input->setAttribute('type', 'submit');
    $input->setAttribute('name', 'DeactivateAll');
    $input->setAttribute('value', 'Deactivate All'); */
    $form->appendChild($input);
    
    
    $formDiv->appendChild($form);
    
    $body->appendChild($formDiv);
    
    
    /*
     *  Insert content here.
     */
    
    
    $body->appendChild(generateFooter($doc));
    if ($prettyPretty)
      $doc->formatOutput = true;
    outputDoc($doc);
  }
else
  generateIndexRedirect();
      
?>